package com.smcic.api.neican.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.smcic.api.neican.dto.LoginDto;
import com.smcic.api.neican.dto.NamePageDTO;
import com.smcic.api.neican.dto.TokenDto;
import com.smcic.api.neican.entity.AdminUsers;
import com.smcic.api.neican.service.impl.AdminUsersServiceImpl;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * <p>
 * 系统管理员用户 前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@RestController
@RequestMapping("/admin/users")
public class AdminUsersController {

    @Resource
    private AdminUsersServiceImpl adminUsersService;

    @PostMapping("list")
    public Page<AdminUsers> list(@RequestBody NamePageDTO namePageDTO) {
        return adminUsersService.usersPage(namePageDTO);
    }

    @PostMapping("add")
    public void add(@RequestBody AdminUsers adminUsers) {
        adminUsersService.create(adminUsers);
    }

    @PostMapping("update")
    public void update(@RequestBody AdminUsers adminUsers) {
        adminUsersService.modify(adminUsers);
    }

    @DeleteMapping("delete/{id}")
    public void delete(@PathVariable Long id) {
        adminUsersService.delete(id);
    }

    @PostMapping("login")
    public TokenDto login(@RequestBody LoginDto loginDto) {
        return adminUsersService.login(loginDto);
    }

    @GetMapping("logout")
    public void logout() {
        adminUsersService.logout();
    }


}
