package com.smcic.api.neican.controller;


import com.smcic.api.neican.entity.MenuModule;
import com.smcic.api.neican.service.impl.MenuModuleServiceImpl;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@RestController
@RequestMapping("/admin/module")
public class MenuModuleController {

    @Resource
    private MenuModuleServiceImpl menuModuleService;

    @GetMapping("/list")
    public List<MenuModule> list(){
        return menuModuleService.adminMenuModule(0L);
    }

    @PostMapping("add")
    public void add(@RequestBody MenuModule menuModule){
        menuModuleService.create(menuModule);
    }

    @PostMapping("update")
    public void update(@RequestBody MenuModule menuModule){
        menuModuleService.update(menuModule);
    }

    @DeleteMapping("delete/{id}")
    public void delete(@PathVariable Long id){
        menuModuleService.delete(id);
    }

    @GetMapping("/client")
    public List<MenuModule> clientMenuModule(){
        return menuModuleService.clientMenuModule();
    }
}
