package com.smcic.core.page;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class PageResponse<T> {
    private List<T> data;
    private long total;

    public static <T> PageResponse<T> load(Page<T> page){
        return new PageResponse<>(page.getRecords(),page.getTotal());
    }

    public static <T> PageResponse<T> load(List<T> data,long total){
        return new PageResponse<>(data,total);
    }
}
